﻿if (app.documents.length != 0){
	if (app.selection.length >0){
		var s = app.selection[0].constructor.name;
		switch (app.selection[0].constructor.name){
			case "Text":
			case "InsertionPoint":
			case "Character":
			case "Word":
			case "Line":
			case "TextStyleRange":
			case "TextColumn":
			case "Paragraph":
				main(false);
				break;
			case "TextFrame":
				var aSel = app.selection;
				var myHeight = false;
				for (var n = 0; n < aSel.length; n++) {
					if (aSel[n].constructor.name == "TextFrame") {
						app.select(aSel[n].texts);
						myHeight = main(myHeight);
					}
				}
				break;
			default:
				alert("Es ist kein Text markiert.");
				break;
		}
	}
	else{
		alert("Es ist nichts markiert.");
	}
}
else{
	alert("Es ist kein Dokument offen.");
}

function main(myHeight) {
	var prevHUnits = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	var prevVUnits = app.activeDocument.viewPreferences.verticalMeasurementUnits;
	app.activeDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	 
	var aStory = app.selection[0].parentStory;
	var tRanges = app.selection[0].textStyleRanges;
	if (myHeight == false) {
		var aSize = app.selection[0].pointSize / getRel(aStory, app.selection[0].index);
		var myDialog = app.dialogs.add({name:"Versalhöhe eingeben"});
		with(myDialog.dialogColumns.add()){
			var vHeightField = measurementEditboxes.add({editValue: aSize, editUnits:MeasurementUnits.points, smallNudge:0.5});
		}
		var myResult = myDialog.show();
		if(myResult == true){
			var vHeight = vHeightField.editValue;
			myDialog.destroy();
		}
		else{
			var vHeight = false;
			myDialog.destroy();
		}
	} else {
		// Damit kann main() der gewünschte wert übergeben werden und muss nicht mehr abgefragt werden.
		var vHeight = myHeight;
	}
	
	if (vHeight != false) {
		for (var n = 0; n < tRanges.length; n++) {
			var aRel = getRel(aStory, tRanges[n].index);
			tRanges[n].pointSize = vHeight * aRel;
		}
	}
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = prevHUnits;
	app.activeDocument.viewPreferences.verticalMeasurementUnits = prevVUnits;	
	return vHeight;
}

function getRel(aStory, anIX) {
		aStory.insertionPoints[anIX+1].contents = "H";;
		var aChar = aStory.characters[anIX+1];
		var aSize = aChar.pointSize;
		var aPath = aChar.createOutlines();
		var bSize = aPath[0].geometricBounds[2]-aPath[0].geometricBounds[0];
		aPath[0].remove();
		return aSize / bSize;
}